<?php

/* Photopress shared include file */
/* first set some defaults that are overridden if there's */
/* previously stored stuff */

load_plugin_textdomain('photopress');

$pp_options = array();

if (get_option('pp_options')) {
	$pp_options = get_option('pp_options');
}

if ($pp_options['pp_originals'] != '0' && $pp_options['pp_originals'] != '1') {
	$pp_options['pp_originals'] = '0';
}
$pp_originals = $pp_options['pp_originals'];

if ($pp_options['pp_show_posts'] != '0' && $pp_options['pp_show_posts'] != '1') {
	$pp_options['pp_show_posts'] = '1';
}
$pp_show_posts = $pp_options['pp_show_posts'];

if ($pp_options['pp_failsafe_buttons'] != '0' && $pp_options['pp_failsafe_buttons'] != '1') {
	$pp_options['pp_failsafe_buttons'] = '0';
}
$pp_failsafe_buttons = $pp_options['pp_failsafe_buttons'];

if ($pp_options['pp_insert_thumb'] != '0' && $pp_options['pp_insert_thumb'] != '1') {
	$pp_options['pp_insert_thumb'] = '1';
}
$pp_insert_thumb = $pp_options['pp_insert_thumb'];

if ($pp_options['pp_album'] != '0' && $pp_options['pp_album'] != '1') {
	$pp_options['pp_album'] = '1';
}
$pp_album = $pp_options['pp_album'];

if ($pp_options['pp_meta_link'] != '0' && $pp_options['pp_meta_link'] != '1') {
	$pp_options['pp_meta_link'] = '1';
}
$pp_meta_link = $pp_options['pp_meta_link'];

if ($pp_options['pp_meta_rand'] != '0' && $pp_options['pp_meta_rand'] != '1') {
	$pp_options['pp_meta_rand'] = '1';
}
$pp_meta_rand = $pp_options['pp_meta_rand'];

if ($pp_options['pp_thumbs_in_manager'] != '0' && $pp_options['pp_thumbs_in_manager'] != '1') {
	$pp_options['pp_thumbs_in_manager'] = '1';
}
$pp_thumbs_in_manager = $pp_options['pp_thumbs_in_manager'];

if (empty($pp_options['pp_album_columns'])) {
	$pp_options['pp_album_columns'] = '2';
}
$pp_album_columns = $pp_options['pp_album_columns'];

if (empty($pp_options['pp_photofolder'])) {
	$pp_options['pp_photofolder'] = 'photos';
}
$pp_photofolder = $pp_options['pp_photofolder'];

if (empty($pp_options['pp_origprefix'])) {
	$pp_options['pp_origprefix'] = 'orig_';
}
$pp_origprefix = $pp_options['pp_origprefix'];

if (empty($pp_options['pp_thumbprefix'])) {
	$pp_options['pp_thumbprefix'] = 'thumb_';
}
$pp_thumbprefix = $pp_options['pp_thumbprefix'];

if (empty($pp_options['pp_thumbsize'])) {
	$pp_options['pp_thumbsize'] = '130';
}
$pp_thumbsize = $pp_options['pp_thumbsize'];

if (empty($pp_options['pp_maxsize'])) {
	$pp_options['pp_maxsize'] = '450';
}
$pp_maxsize = $pp_options['pp_maxsize'];

if (empty($pp_options['pp_maxk'])) {
	$pp_options['pp_maxk'] = '512';
}
$pp_maxk = $pp_options['pp_maxk'];

if (empty($pp_options['pp_allowedtypes'])) {
	$pp_options['pp_allowedtypes'] = 'jpg gif png';
}
$pp_allowedtypes = $pp_options['pp_allowedtypes'];

if (empty($pp_options['pp_quality'])) {
	$pp_options['pp_quality'] = '80';
}
$pp_quality = $pp_options['pp_quality'];

if (empty($pp_options['pp_min_level'])) {
	$pp_options['pp_min_level'] = '2';
}
$pp_min_level = $pp_options['pp_min_level'];

if (empty($pp_options['pp_align'])) {
	$pp_options['pp_align'] = 'centered';
}
$pp_align = $pp_options['pp_align'];

if (empty($pp_options['pp_albumname'])) {
	$pp_options['pp_albumname'] = '?pp_album=1';
}
$pp_albumname = $pp_options['pp_albumname'];

if (empty($pp_options['pp_albumpostfix'])) {
	$pp_options['pp_albumpostfix'] = '&pp_image=';
}
$pp_albumpostfix = $pp_options['pp_albumpostfix'];

if (empty($pp_options['pp_catpostfix'])) {
	$pp_options['pp_catpostfix'] = '&pp_cat=';
}
$pp_catpostfix = $pp_options['pp_catpostfix'];

$pp_home_path = get_settings('home');
if ( $pp_home_path != '' && $pp_home_path != get_settings('siteurl') ) {
	$pp_blogurl = get_settings('home');
	$pp_siteurl = get_settings('siteurl');
	$home_path = parse_url($pp_home_path);
	$home_path = $home_path['path'];
	$root = str_replace($_SERVER["PHP_SELF"], '', $_SERVER["SCRIPT_FILENAME"]);
	$home_path = trailingslashit($root . $home_path);
} else {
	$pp_siteurl = get_settings('siteurl');
	$pp_blogurl = get_settings('siteurl');
	$home_path = ABSPATH;
	$home_path = trailingslashit($root . $home_path);
}

if ($pp_album == '1') {
	$pp_imagelink = $pp_siteurl . '/' . $pp_albumname . $pp_albumpostfix;
	$pp_target = '_top';
} else {
	$pp_imagelink = $pp_blogurl . '/wp-content/' . $pp_photofolder . '/';
	$pp_target = '_blank';
}

$pp_albumaddress = $pp_siteurl . '/' . $pp_albumname;
$pp_photosaddress = $pp_blogurl . '/wp-content/' . $pp_photofolder;
$pp_photospath = $home_path . 'wp-content/' . $pp_photofolder;

/* shared update function so the uploader can save data to the table receives an array which should include filename, short image name, image description, and image category. */
function pp_table_update ($pp_update_array) {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . "photopress";
	if (count($pp_update_array) == 4) {
		if ($wpdb->get_row("SELECT imgfile,imgname,imgdesc,imgcat FROM $table_name WHERE imgfile = '$pp_update_array[0]'")) {
			$update = "UPDATE ".$table_name." SET imgname='".$pp_update_array[1]."',imgdesc='".$pp_update_array[2]."',imgcat='".$pp_update_array[3]."' WHERE imgfile='".$pp_update_array[0]."'";
			$results = $wpdb->query( $update );
		} elseif ($wpdb->get_var("show tables like '$table_name'") == $table_name) {
			$insert = "INSERT INTO ".$table_name.
			" (imgfile,imgname,imgdesc,imgcat) ".
			"VALUES ('".$pp_update_array[0]."','".$pp_update_array[1]."','".$pp_update_array[2]."','".$pp_update_array[3]."')";
			$results = $wpdb->query( $insert );
		}
	}
}

function pp_get_data ($pp_imgfile) {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . "photopress";
	if ($wpdb->get_var("show tables like '$table_name'") == $table_name) {
		$results = $wpdb->get_row("SELECT imgfile,imgname,imgdesc,imgcat FROM $table_name WHERE imgfile = '$pp_imgfile'", ARRAY_A);
	}
	if (count($results) == 4) {
		return $results;
	} else {
		return FALSE;
	}
}

/* function to get an array of categories */
function pp_list_cats() {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . "photopress";
	if ($wpdb->get_var("show tables like '$table_name'") == $table_name) {
		$results = $wpdb->get_col("SELECT imgcat FROM $table_name");
	}
	if(pp_cat_images('Default')) {
		$results[] = 'Default';
	}
	if (count($results) > 0) {
		$results = array_unique($results);
		$results = array_filter($results, 'pp_has_images');
		sort($results);
		return $results;
	} else {
		return FALSE;
	}
}

function pp_has_images($category) {
	$pp_cat_images = pp_cat_images($category);
	if (!empty($pp_cat_images)) {
	return TRUE;
	} else {
		return FALSE;
	}
}

/* function to return an array of the images in a category */
function pp_cat_images($category) {
	global $table_prefix, $wpdb;
	$cat_for_query = $wpdb->escape($category);
	$images_in_folder = array();
	$images_in_cat = array();
	$images_in_db = array();
	$results = array();
	if (pp_folder_contents()) {
		$images_in_folder = pp_folder_contents();
		$table_name = $table_prefix . "photopress";
		if ($wpdb->get_var("show tables like '$table_name'") == $table_name) {
			$images_in_cat = $wpdb->get_col("SELECT imgfile FROM $table_name WHERE binary imgcat='$cat_for_query'");
			$images_in_db = $wpdb->get_col("SELECT imgfile FROM $table_name");
		}
	// add orphan images to the Default category
		if ($category == 'Default') {
			$results = array_diff($images_in_folder,$images_in_db);
			$results = array_merge((array)$results,(array)$images_in_cat);
			sort($results);
		} else {
			$results = $images_in_cat;
			sort($results);
		}
		if (empty($results)) {
			return FALSE;
		} else {
			return $results;
		}
	} else {
		return FALSE;
	}
}

/* returns an array of image names within $pp_photospath with */
/* matching thumbs (ignores images without thumbs) */
/* doesn't check whether the images have data in the db */
function pp_folder_contents() {
	global $pp_photospath, $pp_thumbprefix, $pp_allowedtypes;
	$allowedtypes = trim(strtolower($pp_allowedtypes));
	$allowedtypes = preg_replace("/ /","|",$allowedtypes);
	$fileglob = '@\.(' . $allowedtypes . ')$@i';
	$handle = opendir($pp_photospath);
	$list_array = array();
	while (false !== ($folder_contents = readdir($handle))) {
		$image_name = substr($folder_contents, strlen($pp_thumbprefix));
		if ((preg_match($fileglob, $folder_contents)) && (strstr($folder_contents, $pp_thumbprefix)) && is_file($pp_photospath . '/' . $image_name)) { // make sure both thumb and regular image are there
			$list_array[] = $image_name;
		}
	}
	if (count($list_array) > 1) {
		sort($list_array);
	}
	if (count($list_array) > 0) {
		return $list_array;
	} else {
		return FALSE;
	}
}

?>
